#include <semaphore.h>
#include <pthread.h>
#include <stdio.h>

#define THREADCOUNT 50

sem_t mutex;
int count;

void *myThread(void *arg) {
    int c1;

    sem_wait(&mutex);
    
    // Inizio sezione critica
    // Nessun rischio di scritture incrociate
    for(c1=0;c1<100;c1++)
        count++;
    // Fine sezione critica

    sem_post(&mutex);
    return NULL;
}

int main(int argc, char *argv[]) {
    int c1;
    pthread_t thread[THREADCOUNT];
    
    // Il semaforo deve essere inizializzato a 1
    // perch si comporti come un mutex
    sem_init(&mutex, 0, 1);
    
    // Avviamo i thread
    for(c1=0;c1<THREADCOUNT;c1++)
        pthread_create(&thread[c1], NULL, myThread, NULL);

    // Attendiamo la conclusione di tutti i thread
    for(c1=0;c1<THREADCOUNT;c1++)
        pthread_join(thread[c1], NULL);
    
    printf("Totale: %d\n", count);

    return 0;
}
